/*
    $Id: nv_mul_mfvf_vf.c,v 1.2 1995/04/24 23:24:31 krste Exp $

    Matrix-vector multiply, out_vec = in_matrix * in_vec.
*/

#include "fltvec.h"

#ifdef FUNC_nv_mul_mfvf_vf

#define FP_TYPE float
#define FUNC_NAME nv_mul_mfvf_vf

void
FUNC_NAME(size_t rows, size_t cols,
          const FP_TYPE *in_mat, const FP_TYPE *in_vec, FP_TYPE *out_vec)
{

    size_t i;
    size_t j;

    for (i=0; i<rows; i++)
    {
        FP_TYPE sum = 0.0;
        const FP_TYPE *inp = in_vec;
        for (j=0; j<cols; j++)
        {
            sum += (*in_mat++) * (*inp++);
        }
        *out_vec++ = sum;
    }
}

#endif
