/* Code generated by ./gen_mul_mfvf_vf */
/* Version: $Header: /n/pho/da/krste/tools/phipac/mul_mfvf_vf/RCS/gen_mul_mfvf_vf.c,v 1.3 1995/04/26 04:53:51 krste Exp krste $ */
/* n_rows=4 n_cols=4 */

#include "fltvec.h"

#ifdef FUNC_php_mul_mfvf_vf
#define TYPE float
#define NAME php_mul_mfvf_vf
#define MULSUM_VFVF_F php_mulsum_vfvf_f
#endif

#ifdef FUNC_php_mul_mdvd_vd
#define TYPE double
#define NAME php_mul_mdvd_vd
#define MULSUM_VFVF_F php_mulsum_vdvd_d
#endif

#define RB (4)
#define RC (4)

void
NAME(const size_t rows, const size_t cols,
          const TYPE* mat, const TYPE* vec, TYPE* res)
{
	const TYPE *rowp = mat;
	size_t i;

	const size_t last_block_row = rows & ~(RB-1);
	const TYPE* end_inp = vec + cols;

	const TYPE* end_col_unrollp = vec + (cols & ~(RC-1));
	for (i = 0 ; i != last_block_row; i += RB)
	{
		TYPE rsum0 = 0.0;
		const TYPE* rp0 = rowp;
		TYPE rsum1 = 0.0;
		const TYPE* rp1 = rp0 + cols;
		TYPE rsum2 = 0.0;
		const TYPE* rp2 = rp1 + cols;
		TYPE rsum3 = 0.0;
		const TYPE* rp3 = rp2 + cols;

		const TYPE* inp;
		for (inp = vec; inp != end_col_unrollp; inp += RC)
		{
			const TYPE velem0 = inp[0];
			const TYPE velem1 = inp[1];
			const TYPE velem2 = inp[2];
			const TYPE velem3 = inp[3];

			rsum0 += velem0 * rp0[0];
			rsum1 += velem0 * rp1[0];
			rsum2 += velem0 * rp2[0];
			rsum3 += velem0 * rp3[0];

			rsum0 += velem1 * rp0[1];
			rsum1 += velem1 * rp1[1];
			rsum2 += velem1 * rp2[1];
			rsum3 += velem1 * rp3[1];

			rsum0 += velem2 * rp0[2];
			rsum1 += velem2 * rp1[2];
			rsum2 += velem2 * rp2[2];
			rsum3 += velem2 * rp3[2];

			rsum0 += velem3 * rp0[3];
			rsum1 += velem3 * rp1[3];
			rsum2 += velem3 * rp2[3];
			rsum3 += velem3 * rp3[3];
			rp0 += RC;
			rp1 += RC;
			rp2 += RC;
			rp3 += RC;
		}

		for ( ; inp != end_inp; inp++)
		{
			const TYPE velem = *inp;

			rsum0 += velem * (*rp0++);
			rsum1 += velem * (*rp1++);
			rsum2 += velem * (*rp2++);
			rsum3 += velem * (*rp3++);
		}

		res[0] = rsum0;
		res[1] = rsum1;
		res[2] = rsum2;
		res[3] = rsum3;

		res += RB;

		rowp = rp3;
	}

	for ( ; i<rows; i++)
	{
		*res++ = MULSUM_VFVF_F(cols, rowp, vec);
		rowp += cols;
	}
}
